Subject: Re: Last Call: <draft-ietf-slim-negotiating-human-language-06.txt> (Negotiating Human Language in Real-Time Communications) to Proposed Standard

From: Gunnar Hellström <[email-masked]>
Date: Mon, 13 Feb 2017 11:34:53 +0100

I have reviewed draft-ietf-slim-negotiating-human-language-06.txt and 
have composed a proposed edited version adjusted for my comments below, 
and additionally for some minor editorial issues.

The attached version is a rough edit of the txt file version. Accepted 
edits need to be re-done in the XML version.

Please use a diff to find all edit proposals. The main ones are listed 
below with reference to sections in the files.

-------------------------------------------------------------------------------------------------

1. Inexact wording about the syntax of the new attributes.

Sections 5 and 5.2,  .

The text sometimes indicate that the value of the attributes is a 
language tag, and sometimes a language tag with an optionally appended 
asterisk. The syntax shown in section 5.2 is also not in alignment with 
the syntax shown in section 6. In 5.2 it is shown without the optional 
asterisk, and in 6 with the optional asterisk.

Proposed action:  Make the attribute syntax equal in sections 5.2 and 6. 
Make sure that when "Language-Tag" is mentioned, it is only about the 
language tag part of the attribute value, and when the attribute value 
is mentioned, it is about the complete value, including the optional 
modifier.

Changes:

Last line in 5.  Change "be" to "contain"

Add [ asterisk ] last in both syntax lines in 5.2.

Multiple small changes in section 5.2. to adjust wording to be more 
exact. - See attached draft.

--------------------------------------------------------------------------------------------------------------------------------

2. Reminiscense of earlier syntax.

In a couple of places, there is wording left over from a recently 
abandoned syntax for the attributes. In an earlier version, each 
attribute value could contain multiple language-tags. Now, there is just 
one language-tag in each attribute value.

Changes:
At end of page 6:
Old:  "The values constitute a list of languages in preference order"

New: "The values from multiple attributes constitute a list of languages 
in preference order per direction"

At end of Section 5.3, the comparison with Accept-Language syntax is not 
valid anymore.

Delete: "(similar to SIP Accept-Language syntax)"

----------------------------------------------------------------------------------------------------------------------------------

3. Inexact wording about O/A procedure in section 5.2

The answers are called "accepted language", but within paranthesis it is 
mentioned that it is only in most cases that it is selected from the 
offer. More suitable is then to just call it just "language":

Old:
" In an answer, 'humintlang-send' is the accepted language the answerer
will send (which in most cases is one of the languages in the offer's
'humintlang-recv'), and 'humintlang-recv' is the accepted language
the answerer expects to receive (which in most cases is one of the
languages in the offer's 'humintlang-send')."

New:

"In an answer, 'humintlang-send' indicates the language the answerer
will send (which in most cases is one of the languages in the offer's
'humintlang-recv'), and 'humintlang-recv' indicates the language
the answerer expects to receive (which in most cases is one of the
languages in the offer's 'humintlang-send')."

-----------------------------------------------------------------------------------------------

4. Inexact note at end of section 5.2.

The note at end of 5.2 has a short discussion about accepted media as if 
it should possibly be influenced by the matching languages. This 
discussion is not really valid. A media section is a request to set up a 
media stream, unrelated to the language indications. The devices should 
deny media because they are not needed for language communication. This 
is made more clear in an extended note.

Old:

     "Note that media and language negotiation might result in more media
     streams being accepted than are needed by the users (e.g., if more
     preferred and less preferred combinations of media and language are
     all accepted)."

New:

"Note that media and language negotiation might result in more media
streams being accepted than are needed by the users for language
exchange (e.g., if more preferred and less preferred combinations
of media and language are all accepted). This is normal and accepted,
because the humintlang attribute is not intended to restrict media
streams to be used only for language exchange."

---------------------------------------------------------------------------------

5. Make use of the asterisk modifier on media level with session scope 
also for media level purposes

The asterisk modifier optionally appended on attribute values has in the 
original -06 draft only a session effect. It is specified to indicate if 
the call should be rejected or not if languages do not match. It can be 
appended to any humintlang attribute in the whole SDP without any change 
in effect. This independancy of placement indicates that it is wrongly 
placed. With the current definition, it should be a single separate 
session level attribute. Instead of specifying a separate session level 
attribute, it is proposed that the asterisk gets an expanded definition, 
so that its placement conveys meaning of value for the successful 
language negotiation.

It has been discussed in the SLIM WG that the specification lacks two 
functions, required by the specifications by other bodies who are 
waiting for the results of SLIM real-time work. (e.g. 3GPP TS 22.228 and 
ETSI TR 103 201). 3GPP TS 22.228 requires "The system should be able to 
negotiate the user's desired language(s) and modalities, per media 
stream and/or session, in order of preference." Thus negotiation
with preference indication within the session is required, not only 
within each media.
ETSI TR 103 201 says "the Total Conversation user should be able to 
indicate the preferred method of communication for each direction of the 
session, so that the call-taker can be selected appropriately or an 
appropriate assisting service be invoked. " Saying "preferred" means
that it should also be possible to indicate less preferred alternatives.

The most urgent of these functions can be fulfilled in a simple but 
sufficient way by extending the meaning of the asterisk. That is the 
possibility to indicate a difference in preference between languages in 
different modalities. There is an apparent risk that many calls will 
start and continue in an inconvenient modaity if this differentiation is 
not introduced. See the proposed replaced section 5.3 and extended 
examples in section 5.5.

Earlier discussions on this topic has not resulted in a sufficiently 
simple mechanism. The extended use of the asterisk proposed here is 
intended to introduce the required simplification, and yet meet the most 
urgent needs.

Changes:

In 5.2

Old:

"In an offer, each language tag value MAY have an asterisk appended as
the last character (after the language tag).  The asterisk indicates
a request by the caller to not fail the call if there is no language
in common."

New:

"In an offer or answer, each attribute value MAY have a modifier 
appended as the last character (after the Language-Tag). This 
specification defines one value for the modifier; an asterisk ("*"). The 
asterisk included in a humintlang attribute value in the SDP indicates a 
lower preference for the indicated language and a request by the caller 
to not reject the call if there is no language in common."

In 5.3. The whole section replaced by:

"
5.3.  Preferences within the session

It is of high importance for a smooth start of a call that the
answering party is answering the call using the best matching
language(s) and modality(ies) suitable for the continuation of the call.
Switching language and modality during the call by agreement between
the participants is often time consuming. Without support of detailed
language and modality negotiation the particiants may have a tendency
to continue the call in the initial language and modality even if a
more convenient common language and modality combination is available.
In order to support the decision on which of the available language(s)
and modality(ies) to use initially in the call, a simple two-level
preference indicator is specified here for inclusion as a modifier
in the humintlang attribute values. The preference indicator is also
used as an indicator that the call SHOULD be established even if no
language match is found.

The asterisk ("*") is used as a preference indicator within the session.
Low relative preference for a language and modality to be used in the
session SHOULD be indicated by appending an asterisk after the language
tag in the attribute value. This indication from the offering party
SHOULD be interpreted by the answering party as a request to use a
higher preferred language and modality when answering the call if
available, but otherwise accept a lower preferred language and
modality combination if that is available. When satisfying languages
and modalities in the offer is regarded to be so important that the
whole call SHOULD be rejected if no match can be provided in the
session in one or both directions, then the asterisk shall not be
appended on any indicated language in the whole session description.
For the case when no specific preference is desired, but the offering
party does not want the call to be rejected, all indicated languages
and modalities SHOULD have an asterisk appended.

In an answer, the language(s) and modality(ies) that the answering
party will use initially in the answer SHOULD be indicated without
an appended asterisk. Any language and modality available for later
use in the session MAY be indicated by a language tag with an
appended asterisk.

In the case when more than two parties participate in the call,
the language and modality indications provided to each party
SHOULD be the sum of the indications from the other parties.

The use of the preference indicator as specified above does
not provide for distinguishing between the case when two or
more language/modality combinations in the same direction
are desired for use simultaneously versus the case when two
or more language/modality combinations for the same directions
are provided as selectable alternatives without specific
preference differentiation. The context or other specifications
may introduce the possibility to distinguish between these cases.
When a party in a call has no indications that two or more
language/modality combinations for each direction are desired
simultaeously in the call, the party SHOULD assume that
satisfying one is sufficient.

Other specifications may add other attribute value modifiers than
the asterisk. If an unknown modifier is detected, the modifier
SHALL be ignored."

In section 6.

Reference to semantics in the attribute registrations are expanded from 
5.2 to 5.2-5.3.

---------------------------------------------------------------------------------------------------

6. The cases in the "Silly states" section 5.4 are not all silly.

Section 5.4 contains some proposed interpretations of unusual language 
indications.

They are not silly, but just unusual. Therefore change the name of the 
section to

"5.4 Unusual indications"

The section contains too weak specification about what to do with the 
unusual indications. That may cause a risk that a user who gets 
accustomed to one behavior in contact with certain UAs, suddeenly gets 
another behavior in contact with another UA.

Change:
Old:

"An offer MUST NOT be created where the language does not make sense
for the media type.  If such an offer is received, the receiver MAY
reject the media, ignore the language specified, or attempt to
interpret the intent (e.g., if American Sign Language is specified
for an audio media stream, this might be interpreted as a desire to
use spoken English)."

To:

"An offer MUST NOT be created where the language does not make sense
for the media type.  If such an offer is received, the receiver SHOULD
ignore the language specified."

Also add the following at the end of 5.4 to explain the choice of 
interpretation of a spoken/written language tag in a video medium to be 
a request to see the speaker rather than having text captions overlayed 
on video.

"There is no difference between language tags for spoken and written
languages. The spoken or written language tag indicated for a video
stream could therefore be interpreted as a capability or request to
use text captions overlayed on the video stream. The interpretation
according to this specification SHALL however be to have a view of
the speaker."

-----------------------------------------------------------------------------------------------------------

7. Examples section 5.5 requires expansion

Section 5.5 Examples has very little explanations and show just a few 
cases. The section is proposed to be expanded, with O/A examples with 
descriptions and alternative outcomes in order to more thoroughly 
describe the intended use.

See 5.5 in the the attached file for the proposed expansion.

------------------------------------------------------------------------------------------------------------

8. Include more fields for attribute registration from 4566bis

Section 6 has the form for attribute registration by IANA. There are a 
couple of fields missing that will be important for use of the 
specification in the WebRTC environment.  Include these fields if that 
is allowable according to current IANA procedures and if that does not 
delay the publication of this draft. These fields are needed for use of 
text media in WebRTC.

Change:

In two locations from:
     "Usage Level:  media"

to:

     "Usage Level:  media, dcsa(subprotocol)"

Insert in two locations in the registration forms:
"Mux Category: NORMAL"

---------------------------------------------------------------------------------------------------------------

With these proposed modifications accepted I am convinced that the 
result will be useful for its purpose.

Regards

Gunnar Hellstrom

-----------------------------------------
Gunnar Hellström
Omnitor
[email-masked]
+46 708 204 288

Den 2017-02-06 kl. 16:27, skrev The IESG:
> The IESG has received a request from the Selection of Language for
> Internet Media WG (slim) to consider the following document:
> - 'Negotiating Human Language in Real-Time Communications'
>    <draft-ietf-slim-negotiating-human-language-06.txt> as Proposed
> Standard
>
> The IESG plans to make a decision in the next few weeks, and solicits
> final comments on this action. Please send substantive comments to the
> [email-masked] mailing lists by 2017-02-20. Exceptionally, comments may be
> sent to [email-masked] instead. In either case, please retain the
> beginning of the Subject line to allow automated sorting.
>
> Abstract
>
>
>     Users have various human (natural) language needs, abilities, and
>     preferences regarding spoken, written, and signed languages.  When
>     establishing interactive communication ("calls") there needs to be a
>     way to negotiate (communicate and match) the caller's language and
>     media needs with the capabilities of the called party.  This is
>     especially important with emergency calls, where a call can be
>     handled by a call taker capable of communicating with the user, or a
>     translator or relay operator can be bridged into the call during
>     setup, but this applies to non-emergency calls as well (as an
>     example, when calling a company call center).
>
>     This document describes the need and a solution using new SDP stream
>     attributes.
>
>
>
>
> The file can be obtained via
> https://datatracker.ietf.org/doc/draft-ietf-slim-negotiating-human-language/
>
> IESG discussion can be tracked via
> https://datatracker.ietf.org/doc/draft-ietf-slim-negotiating-human-language/ballot/
>
>
> No IPR declarations have been submitted directly on this I-D.
>
>
> The document contains these normative downward references.
> See RFC 3967 for additional information:
>      draft-saintandre-sip-xmpp-chat: Interworking between the Session Initiation Protocol (SIP) and the Extensible Messaging and Presence Protocol (XMPP): One-to-One Text Chat (None - )
> Note that some of these references may already be listed in the acceptable Downref Registry.
>
>

-- 
-----------------------------------------
Gunnar Hellström
Omnitor
[email-masked]
+46 708 204 288

---

From: Randall Gellens <[email-masked]>
Date: Mon, 13 Feb 2017 14:18:15 -0800

Hi Gunnar,

Please see inline.

At 11:34 AM +0100 2/13/17, Gunnar Hellström wrote:

>  I have reviewed 
> draft-ietf-slim-negotiating-human-language-06.txt 
> and have composed a proposed edited version 
> adjusted for my comments below, and 
> additionally for some minor editorial issues.
>
>  The attached version is a rough edit of the txt 
> file version. Accepted edits need to be re-done 
> in the XML version.
>
>  Please use a diff to find all edit proposals. 
> The main ones are listed below with reference 
> to sections in the files.
>
> 
>  The text sometimes indicate that the value of 
> the attributes is a language tag, and sometimes 
> a language tag with an optionally appended 
> asterisk. The syntax shown in section 5.2 is 
> also not in alignment with the syntax shown in 
> section 6. In 5.2 it is shown without the 
> optional asterisk, and in 6 with the optional 
> asterisk.

I will delete the syntax description from 5.2 to avoid confusion.

>
>  Proposed action:  Make the attribute syntax 
> equal in sections 5.2 and 6. Make sure that 
> when "Language-Tag" is mentioned, it is only 
> about the language tag part of the attribute 
> value, and when the attribute value is 
> mentioned, it is about the complete value, 
> including the optional modifier.
>
>  Changes:
>

I will adjust the text in the last line of 5 and 
clarify the text for the use of "the values" in 
5.2.

>
>  Multiple small changes in section 5.2. to 
> adjust wording to be more exact. - See attached 
> draft.
>
> 
>  In a couple of places, there is wording left 
> over from a recently abandoned syntax for the 
> attributes. In an earlier version, each 
> attribute value could contain multiple 
> language-tags. Now, there is just one 
> language-tag in each attribute value.
>
>  Changes:
>  At end of page 6:
>  New: "The values from multiple attributes 
> constitute a list of languages in preference 
> order per direction"
>
>  At end of Section 5.3, the comparison with 
> Accept-Language syntax is not valid anymore.
>

OK.

>  The answers are called "accepted language", but 
> within paranthesis it is mentioned that it is 
> only in most cases that it is selected from the 

I will delete the two instances of "accepted" in 5.3.

>  The note at end of 5.2 has a short discussion 
> about accepted media as if it should possibly 
> be influenced by the matching languages. This 
> discussion is not really valid. A media section 
> is a request to set up a media stream, 
> unrelated to the language indications. The 
> devices should deny media because they are not 
> needed for language communication. This is made 
> more clear in an extended note.
>
>  Old:
>

I'll clarify the text.

>  5. Make use of the asterisk modifier on media 
> level with session scope also for media level 
> purposes
>
>  The asterisk modifier optionally appended on 
> attribute values has in the original -06 draft 
> only a session effect. It is specified to 
> indicate if the call should be rejected or not 
> if languages do not match. It can be appended 
> to any humintlang attribute in the whole SDP 
> without any change in effect. This independancy 
> of placement indicates that it is wrongly 
> placed. With the current definition, it should 
> be a single separate session level attribute. 
> Instead of specifying a separate session level 
> attribute, it is proposed that the asterisk 
> gets an expanded definition, so that its 
> placement conveys meaning of value for the 
> successful language negotiation.
>
>  It has been discussed in the SLIM WG that the 
> specification lacks two functions, required by 
> the specifications by other bodies who are 
> waiting for the results of SLIM real-time work. 
> (e.g. 3GPP TS 22.228 and ETSI TR 103 201). 3GPP 
> TS 22.228 requires "The system should be able 
> to negotiate the user's desired language(s) and 
> modalities, per media stream and/or session, in 
> order of preference." Thus negotiation
>  with preference indication within the session 
> is required, not only within each media.
>  ETSI TR 103 201 says "the Total Conversation 
> user should be able to indicate the preferred 
> method of communication for each direction of 
> the session, so that the call-taker can be 
> selected appropriately or an appropriate 
> assisting service be invoked. " Saying 
> "preferred" means
>  The most urgent of these functions can be 
> fulfilled in a simple but sufficient way by 
> extending the meaning of the asterisk. That is 
> the possibility to indicate a difference in 
> preference between languages in different 
> modalities. There is an apparent risk that many 
> calls will start and continue in an 
> inconvenient modaity if this differentiation is 
> not introduced. See the proposed replaced 
> section 5.3 and extended examples in section 
> 5.5.
>
>  Earlier discussions on this topic has not 
> resulted in a sufficiently simple mechanism. 
> The extended use of the asterisk proposed here 
> is intended to introduce the required 
> simplification, and yet meet the most urgent 
> needs.

The WG discussed various proposals regarding the 
asterisk and did not reach a conclusion to change 
what is in the draft.

>  "In an offer or answer, each attribute value 
> MAY have a modifier appended as the last 
> character (after the Language-Tag). This 
> specification defines one value for the 
> modifier; an asterisk ("*"). The asterisk 
> included in a humintlang attribute value in the 
> SDP indicates a lower preference for the 
> indicated language and a request by the caller 
>  Reference to semantics in the attribute 
> registrations are expanded from 5.2 to 5.2-5.3.
>
> 
>  Section 5.4 contains some proposed 
> interpretations of unusual language indications.
>
>  They are not silly, but just unusual. Therefore 
> change the name of the section to
>
>  The section contains too weak specification 
> about what to do with the unusual indications. 
> That may cause a risk that a user who gets 
> accustomed to one behavior in contact with 
> certain UAs, suddeenly gets another behavior in 
> contact with another UA.
>
>  Change:
>  Old:
>

OK.

>
>
>  Also add the following at the end of 5.4 to 
> explain the choice of interpretation of a 
> spoken/written language tag in a video medium 
> to be a request to see the speaker rather than 
> having text captions overlayed on video.
>

I don't think we need to talk about how to 
interpret non-signed language tags in a video 
stream.

>  Section 5.5 Examples has very little 
> explanations and show just a few cases. The 
> section is proposed to be expanded, with O/A 
> examples with descriptions and alternative 
> outcomes in order to more thoroughly describe 
> the intended use.
>
>  Section 6 has the form for attribute 
> registration by IANA. There are a couple of 
> fields missing that will be important for use 
> of the specification in the WebRTC environment. 
> Include these fields if that is allowable 
> according to current IANA procedures and if 
> that does not delay the publication of this 
> draft. These fields are needed for use of text 
> media in WebRTC.
>
>  Change:
>
>  In two locations from:
>      "Usage Level:  media"
>
>  to:
>

I think this suggestion exceeds a simple 
editorial change, and therefore would need to be 
discussed on the WG list with WG consensus before 
it can be adopted.  I would also note that these 
fields can be added to the attribute registration 
later, according to the rules for the registry 
(http://www.iana.org/assignments/sdp-parameters/sdp-parameters.xhtml), 
which I believe are "Specification Required."

>  With these proposed modifications accepted I am 
> convinced that the result will be useful for 
> its purpose.
>
>  Regards
>
>  Gunnar Hellstrom
>
>>       draft-saintandre-sip-xmpp-chat: 
>> Interworking between the Session Initiation 
>> Protocol (SIP) and the Extensible Messaging 
>> and Presence Protocol (XMPP): One-to-One Text 
>> Chat (None - )
>>  Note that some of these references may already 
>> be listed in the acceptable Downref Registry.
>>
>
>  --
>  Attachment converted: 
> TiLand:draft-ietf-slim-nego#41BE1A.txt 
> (TEXT/R*ch) (0041BE1A)
>  _______________________________________________
>  SLIM mailing list
>  [email-masked]
>  https://www.ietf.org/mailman/listinfo/slim

-- 
Randall Gellens
Opinions are personal;    facts are suspect;    I speak for myself only
-------------- Randomly selected tag: ---------------
Voltaire said "The art of government consists of taking as much money
as possible from one party of citizens to give to the other."  The
difference between the dominant political parties is which groups they
assign which roles.